Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QDiffractionRatio.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QDiffractionRatio.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QDiffractionRatio.cc	(revision 1055)
@@ -25,13 +25,16 @@
 //
 //
-// $Id: G4QDiffractionRatio.cc,v 1.9 2008/03/21 21:40:08 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QDiffractionRatio.cc,v 1.10 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
-// G4 Physics class: G4QDiffractionRatio for N+A elastic cross sections
+// G4 Physics class: G4QDiffractionRatio for N+A Diffraction Interactions
 // Created: M.V. Kossov, CERN/ITEP(Moscow), 10-OCT-01
 // The last update: M.V. Kossov, CERN/ITEP (Moscow) 15-Oct-06
 // 
-//================================================================================
+//=======================================================================
+// Short description: Difraction excitation is a part of the incoherent
+// (inelastic) interaction. This part is calculated in the class.
+// --------------------------------------------------------------------
 
 //#define debug
@@ -114,5 +117,5 @@
   G4bool found=false;
   G4int i=-1;
-		if(nDB) for (i=0; i<nDB; i++) if(A==vA[i]) // Sirch for this A in AMDB
+  if(nDB) for (i=0; i<nDB; i++) if(A==vA[i]) // Sirch for this A in AMDB
   {
     found=true;                         // The A value is found
@@ -120,5 +123,5 @@
   }
   if(!nDB || !found)                    // Create new line in the AMDB
-	 {
+  {
     lastA = A;
     lastT = new G4double[mps];          // Create the linear Table
@@ -152,5 +155,5 @@
       {
         lastL[j]=CalcDiff2Prod_Ratio(sv,A);
-	       if(j!=lastK) sv*=edl;
+        if(j!=lastK) sv*=edl;
       }
     }
@@ -171,5 +174,5 @@
   }
   else                                  // The A value was found in AMDB
-	 {
+  {
     lastA=vA[i];
     lastH=vH[i];
@@ -199,5 +202,5 @@
       } // End of LinTab update
       if(lastN>=nextN)
-						{
+      {
         vH[i]=lastH;
         vN[i]=lastN;
@@ -205,5 +208,5 @@
       G4int nextK=lastK+1;
       if(s>sma && lastK<nls)             // LogTab must be updated
-						{
+      {
         G4double sv=std::exp(lastM+lsi); // Define starting poit (lastM will be changed)
         G4double ls=std::log(s);
@@ -217,10 +220,10 @@
         for(G4int j=nextK; j<=lastK; j++)// Calculate LogTab values
         {
-	         sv*=edl;
+          sv*=edl;
           lastL[j]=CalcDiff2Prod_Ratio(sv,A);
         }
       } // End of LogTab update
       if(lastK>=nextK)
-						{
+      {
         vM[i]=lastM;
         vK[i]=lastK;
@@ -230,5 +233,5 @@
   // Now one can use tabeles to calculate the value
   if(s<sma)                             // Use linear table
-		{
+  {
     G4int n=static_cast<int>(s/ds);     // Low edge number of the bin
     G4double d=s-n*ds;                  // Linear shift
@@ -236,6 +239,6 @@
     lastR=v+d*(lastT[n+1]-v)/ds;        // Result
   }
-		else                                  // Use log table
-		{
+  else                                  // Use log table
+  {
     G4double ls=std::log(s)-lsi;        // ln(s)-l_min
     G4int n=static_cast<int>(ls/dl);    // Low edge number of the bin
@@ -263,5 +266,5 @@
   if(s<=0. || A<=1) return 0.;
   if(A!=mA && A!=1)
-		{
+  {
     mA=A;
     G4double a=mA;
@@ -281,5 +284,5 @@
     G4double q=std::pow(a,0.7);
     p4=(.036/q+.0009*q)/(1.+6./a3+1.e-7*a3);
-				p5=1.3*std::pow(a,0.1168)/(1.+1.2e-8*a3);
+    p5=1.3*std::pow(a,0.1168)/(1.+1.2e-8*a3);
     p6=.00046*(a+11830./a2);
     p7=1./(1.+6.17/a2+.00406*a);
@@ -297,7 +300,7 @@
   G4double s2=s*s;
   G4double s4=s2*s2;
-		G4double dl=std::log(s)-p5;
+  G4double dl=std::log(s)-p5;
   R=1./(1.+1./(p1+p2/s4+p4*dl*dl/(1.+p6*std::pow(s,p7))));
-	 return R;
+  return R;
 } // End of CalcQF2IN_Ratio
 
@@ -350,5 +353,5 @@
   G4double mT=mNeut;                       // Prototype of mass of QF nucleon
   G4double mT2=mNeut2;                     // Squared mass of a free nucleon to be excited
-  G4double dmT=dmNeut;                     // Doubled mass														
+  G4double dmT=dmNeut;                     // Doubled mass              
   G4int Z=0;                               // Prototype of the isotope Z
   G4int N=1;                               // Prototype of the Isotope N
@@ -357,7 +360,7 @@
     mT=mProt;                              // Prototype of mass of QF nucleon to be excited
     mT2=mProt2;                            // Squared mass of the free nucleon
-    dmT=dmProt;                            // Doubled mass														
-    Z=1;							                            // Z of the isotope
-    N=0;							                            // N of the Isotope
+    dmT=dmProt;                            // Doubled mass              
+    Z=1;                                   // Z of the isotope
+    N=0;                                   // N of the Isotope
   }
   G4double mP2=pr4M.m2();                  // Squared mass of the projectile
@@ -396,5 +399,5 @@
   G4double ds=s-mP2-mDif2;               
   G4double e=ds/dmP;
-		G4double P=std::sqrt(e*e-mDif2);      // Momentum in pseudo laboratory system
+  G4double P=std::sqrt(e*e-mDif2);      // Momentum in pseudo laboratory system
   G4VQCrossSection* CSmanager=G4QElasticCrossSection::GetPointer();
 #ifdef debug
@@ -442,5 +445,5 @@
     else if(cost<-1.) cost=-1.;
     else
-				{
+    {
       G4cerr<<"G4QDiffRat::TargFragm: *NAN* cost="<<cost<<",t="<<t<<",tmax="<<maxt<<G4endl;
       return ResHV;                     // Do Nothing Action
@@ -457,5 +460,5 @@
   }
 #ifdef debug
-		G4cout<<"G4QDifRat::TargFragm:d4M="<<d4M<<"+r4M="<<r4M<<"="<<d4M+r4M<<"="<<tot4M<<G4endl;
+  G4cout<<"G4QDifRat::TargFragm:d4M="<<d4M<<"+r4M="<<r4M<<"="<<d4M+r4M<<"="<<tot4M<<G4endl;
 #endif
   // Now everything is ready for fragmentation and DoNothing projHadron must be wiped out
@@ -465,13 +468,13 @@
   ResHV->push_back(hadron);             // Fill the recoil nucleon
 #ifdef debug
-		G4cout<<"G4QDiffractionRatio::TargFragm: *Filled* LeadingNuc="<<r4M<<pPDG<<G4endl;
-#endif
-  G4QHadronVector* leadhs=new G4QHadronVector;// Quasmon Output G4QHadronVectorum --->---+
+  G4cout<<"G4QDiffractionRatio::TargFragm: *Filled* LeadingNuc="<<r4M<<pPDG<<G4endl;
+#endif
+  G4QHadronVector* leadhs=new G4QHadronVector;// Quasmon Output G4QHadronVectorum --->---*
   G4QContent dQC=G4QPDGCode(rPDG).GetQuarkContent(); // QuarkContent of quasiFreeNucleon | 
-  G4Quasmon* quasm = new G4Quasmon(dQC,d4M); // Quasmon=DiffractionExcitationQuasmon-+   |
+  G4Quasmon* quasm = new G4Quasmon(dQC,d4M); // Quasmon=DiffractionExcitationQuasmon-*   |
 #ifdef debug
-		G4cout<<"G4QDiffRatio::TgFrag:tPDG="<<tPDG<<",rPDG="<<rPDG<<",d4M="<<d4M<<G4endl;//|   |
-#endif
-  G4QEnvironment* pan= new G4QEnvironment(G4QNucleus(tPDG));// --> DELETED --->---+  |   |
+  G4cout<<"G4QDiffRatio::TgFrag:tPDG="<<tPDG<<",rPDG="<<rPDG<<",d4M="<<d4M<<G4endl;//|   |
+#endif
+  G4QEnvironment* pan= new G4QEnvironment(G4QNucleus(tPDG));// --> DELETED --->---*  |   |
   pan->AddQuasmon(quasm);                    // Add diffractiveQuasmon to Environ.|  |   |
 #ifdef debug
@@ -479,16 +482,16 @@
 #endif
   try                                                           //                |  |   |
-	 {                                                             //                |  |   |
-	   delete leadhs;                                              //                |  |   |
+  {                                                             //                |  |   |
+    delete leadhs;                                              //                |  |   |
     leadhs = pan->Fragment();// DESTROYED in the end of the LOOP work space       |  |   |
   }                                                             //                |  |   |
   catch (G4QException& error)//                                                   |  |   |
-	 {                                                             //                |  |   |
-	   //#ifdef pdebug
+  {                                                             //                |  |   |
+    //#ifdef pdebug
     G4cerr<<"***G4QCollision::PostStepDoIt: G4QE Exception is catched"<<G4endl;// |  |   |
-	   //#endif
+    //#endif
     G4Exception("G4QCollision::PostStepDoIt:","27",FatalException,"CHIPSCrash");//|  |   |
   }                                                             //                |  |   |
-  delete pan;                              // Delete the Nuclear Environment <-<--+--+   |
+  delete pan;                              // Delete the Nuclear Environment <-<--*--*   |
   G4int qNH=leadhs->size();                // A#of collected hadrons from diff.frag.     |
   if(qNH) for(G4int iq=0; iq<qNH; iq++)    // Loop over hadrons to fill the result       |
@@ -498,5 +501,5 @@
   }                                        //                                            |
   delete leadhs; // <----<----<----<----<----<----<----<----<----<----<----<----<----<---*
-		return ResHV; // Result
+  return ResHV; // Result
 } // End of TargFragment
 
@@ -588,5 +591,5 @@
   G4double ds=s-mT2-mDif2;
   G4double e=ds/dmT;
-		G4double P=std::sqrt(e*e-mDif2);          // Momentum in pseudo laboratory system
+  G4double P=std::sqrt(e*e-mDif2);          // Momentum in pseudo laboratory system
   G4VQCrossSection* CSmanager=G4QElasticCrossSection::GetPointer();
 #ifdef debug
@@ -632,5 +635,5 @@
     else if(cost<-1.) cost=-1.;
     else
-				{
+    {
       G4cerr<<"G4QDiffRat::ProjFragm: *NAN* cost="<<cost<<",t="<<t<<",tmax="<<maxt<<G4endl;
       return ResHV; // Do Nothing Action
@@ -647,5 +650,5 @@
   }
 #ifdef debug
-		G4cout<<"G4QDiffR::ProjFragm:d4M="<<d4M<<"+r4M="<<r4M<<"="<<d4M+r4M<<"="<<tot4M<<G4endl;
+  G4cout<<"G4QDiffR::ProjFragm:d4M="<<d4M<<"+r4M="<<r4M<<"="<<d4M+r4M<<"="<<tot4M<<G4endl;
 #endif
   // Now everything is ready for fragmentation and DoNothing projHadron must be wiped out
@@ -655,10 +658,10 @@
   ResHV->push_back(hadron);          // Fill the recoil nucleus
 #ifdef debug
-		G4cout<<"G4QDiffractionRatio::ProjFragment: *Filled* RecNucleus="<<t4M<<tPDG<<G4endl;
+  G4cout<<"G4QDiffractionRatio::ProjFragment: *Filled* RecNucleus="<<t4M<<tPDG<<G4endl;
 #endif
   hadron = new G4QHadron(rPDG,r4M);  // Hadron for the recoil nucleon
   ResHV->push_back(hadron);          // Fill the recoil nucleon
 #ifdef debug
-		G4cout<<"G4QDiffractionRatio::ProjFragment: *Filled* RecNucleon="<<r4M<<rPDG<<G4endl;
+  G4cout<<"G4QDiffractionRatio::ProjFragment: *Filled* RecNucleon="<<r4M<<rPDG<<G4endl;
 #endif
   G4LorentzVector sum4M(0.,0.,0.,0.);
@@ -668,10 +671,10 @@
   G4Quasmon* pan= new G4Quasmon(dQC,d4M); // --->---->---->----->-----> DELETED -->---*
   try                                                           //                    |
-	 {                                                             //                    |
+  {                                                             //                    |
     G4QNucleus vac(90000000);                                   //                    |
     leadhs=pan->Fragment(vac,1);  // DELETED after it is copied to ResHV vector -->---+-*
   }                                                             //                    | |
   catch (G4QException& error)                                   //                    | |
-	 {                                                             //                    | |
+  {                                                             //                    | |
     G4cerr<<"***G4QDiffractionRatio::ProjFragment: G4Quasmon Exception"<<G4endl;    //| |
     G4Exception("G4QDiffractionRatio::ProjFragment","72",FatalException,"*Quasmon");//| |
@@ -789,5 +792,5 @@
         }
         else                                          //(2) n*N+m*(Pi-)   (nL=0)        |
-	       {
+        {
           sPDG = -211;
           qPN  = -nC;
@@ -839,5 +842,5 @@
           nB  = nC;
           fMass= mProt;
-	       }
+        }
         else if(nL  && nC<nB-nL) //(3)n*L+m*P+k*N ***Should not be here***              |
         {
@@ -1005,5 +1008,5 @@
 #ifdef fdebug
             sum4M+=r4M;                      // Sum 4-momenta for the EnMom check       |
-  		        G4cout<<"G4QDR::ProjFrag: *additional Nucleon*="<<f4Mom<<fPDG<<G4endl; //   |
+            G4cout<<"G4QDR::ProjFrag: *additional Nucleon*="<<f4Mom<<fPDG<<G4endl; //   |
 #endif
           }
@@ -1026,5 +1029,5 @@
 #ifdef fdebug
             sum4M+=r4M;                      // Sum 4-momenta for the EnMom check       |
-  		        G4cout<<"G4QDR::ProjFragm: *additional Pion*="<<f4Mom<<fPDG<<G4endl; //     |
+            G4cout<<"G4QDR::ProjFragm: *additional Pion*="<<f4Mom<<fPDG<<G4endl; //     |
 #endif
           }
@@ -1047,10 +1050,10 @@
 #ifdef fdebug
             sum4M+=r4M;                    // Sum 4-momenta for the EnMom check         |
-  		        G4cout<<"G4QDR::ProjFragm: *additional Hyperon*="<<f4Mom<<fPDG<<G4endl; //  |
+            G4cout<<"G4QDR::ProjFragm: *additional Hyperon*="<<f4Mom<<fPDG<<G4endl; //  |
 #endif
           }
         }
       }                                    // --> End of decay                          |
-				}                                      // -> End of Iso-nuclear treatment           |
+    }                                      // -> End of Iso-nuclear treatment           |
     else if( (nL > 0 && nB > 1) || (nL < 0 && nB < -1) ) 
     {     // Hypernucleus is found                                                      |
@@ -1067,12 +1070,12 @@
       G4int nSP=0;                         // A#0f unavoidable Sigma+                   |
       if(nC<0)                             // Negative hypernucleus                     |
-	     {
+      {
         if(-nC<=nL)                        // Partial compensation by Sigma-            |
-		      {
+        {
           nSM=-nC;                         // Can be compensated by Sigma-              |
           nL+=nC;                          // Reduce the residual strangeness           |
         }
         else                               // All Charge is compensated by Sigma-       |
-		      {
+        {
           nSM=nL;                          // The maximum number of Sigma-              |
           nL=0;                            // Kill the residual strangeness             |
@@ -1080,7 +1083,7 @@
       }
       else if(nC>nB-nL)                    // Extra positive hypernucleus               |
-	     {
+      {
         if(nC<=nB)                         // Partial compensation by Sigma+            |
-		      {
+        {
           G4int dH=nB-nC;                  // Isotopic shift                            |
           nSP=nL-dH;                       // Can be compensated by Sigma+              |
@@ -1088,5 +1091,5 @@
         }
         else                               // All Charge is compensated by Sigma+       |
-		      {
+        {
           nSP=nL;                          // The maximum number of Sigma+              |
           nL=0;                            // Kill the residual strangeness             |
@@ -1105,5 +1108,5 @@
 #endif
       if(nSP||nSM)                         // Sigma+/- improvement                      |
-	     {
+      {
         if(nL)                             // By mistake Lambda improvement is found    |
         {
@@ -1115,5 +1118,5 @@
         }
         if(nSP)                            // Sibma+ should be decayed                  |
-		      {
+        {
           nL=nSP;                          // #of decaying hyperons                     |
           sPDG=3222;                       // PDG code of decaying hyperons             |
@@ -1121,5 +1124,5 @@
         }
         else                               // Sibma+ should be decayed                  |
-		      {
+        {
           nL=nSM;                          // #of decaying hyperons                     |
           sPDG=3112;                       // PDG code of decaying hyperons             |
@@ -1133,5 +1136,5 @@
       G4double rlM=G4QNucleus(rlPDG).GetMZNS();// Mass of the NonstrangeNucleus         |
       if(!nSP&&!nSM&&nL==1&&reM>rlM+mSigZ&&G4UniformRand()>.5) // Conv Lambda->Sigma0   |
-	     {
+      {
         sPDG=3212;                         // PDG code of a decaying hyperon            |
         MLa=mSigZ;                         // Mass of the decaying hyperon              |
@@ -1142,5 +1145,5 @@
       // @@ In future take into account Iso-Hypernucleus (Add PI+,R & Pi-,R decays)     |
       if(rlPDG==90000000)                  // Multy Hyperon (HyperNuc of only hyperons) |
-	     {
+      {
         if(nL>1) r4M=r4M/nL;               // split the 4-mom for the MultyLambda       |
         for(G4int il=0; il<nL; il++)       // loop over Lambdas                         |
@@ -1151,15 +1154,15 @@
 #ifdef fdebug
           sum4M+=r4M;                      // Sum 4-momenta for the EnMom check         |
-  		      G4cout<<"G4QDR::ProjFrag: *additional Lambda*="<<r4M<<sPDG<<G4endl; //        |
-#endif
-        }
-      }
-	     else if(reM>rlM+MLa-eps)              // Lambda (or Sigma) can be split           |
-	     {
+          G4cout<<"G4QDR::ProjFrag: *additional Lambda*="<<r4M<<sPDG<<G4endl; //        |
+#endif
+        }
+      }
+      else if(reM>rlM+MLa-eps)              // Lambda (or Sigma) can be split           |
+      {
         G4LorentzVector n4M(0.,0.,0.,rlM);  // 4-mom of the residual nucleus            |
         G4LorentzVector h4M(0.,0.,0.,MLa);  // 4-mom of the Hyperon                     |
         G4double sum=rlM+MLa;               // Safety sum                               |
-        if(std::fabs(reM-sum)<eps)               // At rest in CMS                           |
-	       {
+        if(std::fabs(reM-sum)<eps)          // At rest in CMS                           |
+        {
           n4M=r4M*(rlM/sum);                // Split tot 4-mom for resNuc               |
           h4M=r4M*(MLa/sum);                // Split tot 4-mom for Hyperon              |
@@ -1178,5 +1181,5 @@
         loh->SetQPDG(G4QPDGCode(rlPDG));   // ConvertedHypernucleus to nonstrange(@anti)|
         if(rlPDG==90000002)                // Additional action with loH changed to 2n  |
-	       {
+        {
           G4LorentzVector newLV=n4M/2.;    // Split 4-momentum                          |
           loh->Set4Momentum(newLV);        // Reupdate the hadron                       |
@@ -1187,9 +1190,9 @@
 #ifdef fdebug
           sum4M+=r4M;                      // Sum 4-momenta for the EnMom check         |
-  		      G4cout<<"G4QDR::ProgFrag: *additional Neutron*="<<r4M<<sPDG<<G4endl; //       |
+          G4cout<<"G4QDR::ProgFrag: *additional Neutron*="<<r4M<<sPDG<<G4endl; //       |
 #endif
         }
         else if(rlPDG==90002000)           // Additional action with loH change to 2p   |
-	       {
+        {
           G4LorentzVector newLV=n4M/2.;    // Split 4-momentum                          |
           loh->Set4Momentum(newLV);        // Reupdate the hadron                       |
@@ -1200,5 +1203,5 @@
 #ifdef fdebug
           sum4M+=r4M;                      // Sum 4-momenta for the EnMom check         |
-  		      G4cout<<"G4QDR::ProjFrag: *additional Proton*="<<r4M<<sPDG<<G4endl; //        |
+          G4cout<<"G4QDR::ProjFrag: *additional Proton*="<<r4M<<sPDG<<G4endl; //        |
 #endif
         }
@@ -1215,10 +1218,10 @@
 #ifdef fdebug
           sum4M+=r4M;                      // Sum 4-momenta for the EnMom check         |
-  		      G4cout<<"G4QDR::ProjFrag: *additional Hyperon*="<<r4M<<sPDG<<G4endl; //       |
-#endif
-        }
-      }
-	     else if(reM>rnM+mPi0-eps&&!nSP&&!nSM)// Lambda->N only if Sigmas are absent       |
-	     {
+          G4cout<<"G4QDR::ProjFrag: *additional Hyperon*="<<r4M<<sPDG<<G4endl; //       |
+#endif
+        }
+      }
+      else if(reM>rnM+mPi0-eps&&!nSP&&!nSM)// Lambda->N only if Sigmas are absent       |
+      {
         G4int nPi=static_cast<G4int>((reM-rnM)/mPi0); // Calc. pion multiplicity        |
         if (nPi>nL) nPi=nL;                // Cut the pion multiplicity                 |
@@ -1227,6 +1230,6 @@
         G4LorentzVector h4M(0.,0.,0.,npiM);// 4-momentum of pions                       |
         G4double sum=rnM+npiM;             // Safety sum                                |
-        if(std::fabs(reM-sum)<eps)              // At rest                                   |
-	       {
+        if(std::fabs(reM-sum)<eps)         // At rest                                   |
+        {
           n4M=r4M*(rnM/sum);               // The residual nucleus part                 |
           h4M=r4M*(npiM/sum);              // The pion part                             |
@@ -1251,9 +1254,9 @@
 #ifdef fdebug
           sum4M+=r4M;                      // Sum 4-momenta for the EnMom check         |
-  		      G4cout<<"G4QDR::ProjFrag: *additional Pion*="<<r4M<<sPDG<<G4endl; //          |
+          G4cout<<"G4QDR::ProjFrag: *additional Pion*="<<r4M<<sPDG<<G4endl; //          |
 #endif
         }
         if(rnPDG==90000002)                // Additional action with loH change to 2n   |
-	       {
+        {
           G4LorentzVector newLV=n4M/2.;    // Split 4-momentum                          |
           loh->Set4Momentum(newLV);        // Reupdate the hadron                       |
@@ -1264,9 +1267,9 @@
 #ifdef fdebug
           sum4M+=r4M;                      // Sum 4-momenta for the EnMom check         |
-  		      G4cout<<"G4QDR::ProjFrag: *additional Neutron*="<<r4M<<sPDG<<G4endl; //       |
+          G4cout<<"G4QDR::ProjFrag: *additional Neutron*="<<r4M<<sPDG<<G4endl; //       |
 #endif
         }
         else if(rnPDG==90002000)           // Additional action with loH change to 2p   |
-	       {
+        {
           G4LorentzVector newLV=n4M/2.;    // Split 4-momentum                          |
           loh->Set4Momentum(newLV);        // Reupdate the hadron                       |
@@ -1277,5 +1280,5 @@
 #ifdef fdebug
           sum4M+=r4M;                      // Sum 4-momenta for the EnMom check         |
-  		      G4cout<<"G4QDR::ProjFrag: *additional Proton*="<<r4M<<sPDG<<G4endl; //        |
+          G4cout<<"G4QDR::ProjFrag: *additional Proton*="<<r4M<<sPDG<<G4endl; //        |
 #endif
         }
@@ -1283,23 +1286,23 @@
       }
       else // If this Excepton shows up (lowProbable appearance) => include gamma decay |
-	     {
+      {
         G4double d=rlM+MLa-reM;            // Hyperon Excessive energy                  |
-		      G4cerr<<"G4QDR::PF:R="<<rlM<<",S+="<<nSP<<",S-="<<nSM<<",L="<<nL<<",d="<<d<<G4endl;
+        G4cerr<<"G4QDR::PF:R="<<rlM<<",S+="<<nSP<<",S-="<<nSM<<",L="<<nL<<",d="<<d<<G4endl;
         d=rnM+mPi0-reM;                    // Pion Excessive energy                     |
-		      G4cerr<<"G4QDR::PF:"<<oPDG<<","<<hPDG<<",M="<<reM<<"<"<<rnM+mPi0<<",d="<<d<<G4endl;
+        G4cerr<<"G4QDR::PF:"<<oPDG<<","<<hPDG<<",M="<<reM<<"<"<<rnM+mPi0<<",d="<<d<<G4endl;
         throw G4QException("G4QDiffractionRatio::ProjFragment: Hypernuclear conver");// |
       }
-		  }                                      // => End of G4 Hypernuclear decay           |
+    }                                      // => End of G4 Hypernuclear decay           |
     ResHV->push_back(loh);                 // Fill in the result                        |
 #ifdef debug
     sum4M+=loh->Get4Momentum();            // Sum 4-momenta for the EnMom check         |
-  		G4cout<<"G4QDR::PrFra:#"<<iq<<","<<loh->Get4Momentum()<<loh->GetPDGCode()<<G4endl;//|
+    G4cout<<"G4QDR::PrFra:#"<<iq<<","<<loh->Get4Momentum()<<loh->GetPDGCode()<<G4endl;//|
 #endif
   }                                        //                                           |
   delete leadhs; // <----<----<----<----<----<----<----<----<----<----<----<----<----<--*
 #ifdef debug
-		G4cout<<"G4QDiffractionRatio::ProjFragment: *End* Sum="<<sum4M<<" =?= d4M="<<d4M<<G4endl;
-#endif
-		return ResHV; // Result
+  G4cout<<"G4QDiffractionRatio::ProjFragment: *End* Sum="<<sum4M<<" =?= d4M="<<d4M<<G4endl;
+#endif
+  return ResHV; // Result
 } // End of ProjFragment
 
@@ -1312,5 +1315,5 @@
          <<pPDG<<G4endl;
   G4double A=Z+N;                        // A of the target
-		//return 4.5*std::pow(A,.364)*millibarn; // Result
+  //return 4.5*std::pow(A,.364)*millibarn; // Result
   return 3.7*std::pow(A,.364)*millibarn; // Result after mpi0 correction
 
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QDiscProcessMixer.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QDiscProcessMixer.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QDiscProcessMixer.cc	(revision 1055)
@@ -24,14 +24,14 @@
 // ********************************************************************
 //
-// $Id: G4QDiscProcessMixer.cc,v 1.4 2008/10/02 21:10:07 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QDiscProcessMixer.cc,v 1.8 2009/04/22 12:26:13 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
-//      ---------------- G4QDiscProcessMixer class -----------------
+//      ---------------- G4QDiscProcessMixer class -------------------
 //                 by Mikhail Kossov, Aug 2007.
 // G4QDiscProcessMixer class of the CHIPS Simulation Branch in GEANT4
-// ---------------------------------------------------------------
-// ****************************************************************************************
-// ********** This CLASS is temporary moved from the "chips/interface" directory *********
-// ****************************************************************************************
+// ------------------------------------------------------------------------
+// Short description: universal mixer of processes (NOT models as in GHAD!)
+// depending on the application energy region (defined by users).
+// ------------------------------------------------------------------------
 
 //#define debug
@@ -54,20 +54,31 @@
 G4QDiscProcessMixer::~G4QDiscProcessMixer()
 {
-  for_each(theDPVector.begin(), theDPVector.end(), DeleteDiscreteProcess());
+  // Now the responsibility of deleting is deligated to the user, who created them
+  //for_each(theDPVector.begin(), theDPVector.end(), DeleteDiscreteProcess());
 }
 
 void G4QDiscProcessMixer::AddDiscreteProcess(G4VDiscreteProcess* DP, G4double ME)
 {
-  if(ME>theDPVector[theDPVector.size()-1]->second)
+  static const G4double maxEn = 1.E8*megaelectronvolt; // Conditional INF
+  if(!theDPVector.size()) // The first process in the DiscreteProcessVector (MaxE=INF)
   {
     std::pair<G4VDiscreteProcess*, G4double>* QDiscProc =
-      new std::pair<G4VDiscreteProcess*, G4double>(DP, ME);
+      new std::pair<G4VDiscreteProcess*, G4double>(DP, maxEn);
     theDPVector.push_back( QDiscProc );
   }
-  else // Wrong Max Energy Order for the new process in the sequence of processes
+  else
   {
-    G4cerr<<"G4QDiscProcessMixer::AddDiscreteProcess:LastMaxE("<<theDPVector.size()-1<<")="
-          <<theDPVector[theDPVector.size()-1]->second<<" >= MaxE="<<ME<<G4endl;
-    G4Exception("G4QDiscProcessMixer::AddDiscreteProcess: Wrong Max Energy Order");
+    if(ME<theDPVector[theDPVector.size()-1]->second)
+    {
+      std::pair<G4VDiscreteProcess*, G4double>* QDiscProc =
+        new std::pair<G4VDiscreteProcess*, G4double>(DP, ME);
+      theDPVector.push_back( QDiscProc );
+    }
+    else // Wrong Max Energy Order for the new process in the sequence of processes
+    {
+      G4cerr<<"G4QDiscProcessMixer::AddDiscreteProcess:LastMaxE("<<theDPVector.size()-1
+            <<")="<<theDPVector[theDPVector.size()-1]->second<<" <= MaxE="<<ME<<G4endl;
+      G4Exception("G4QDiscProcessMixer::AddDiscreteProcess: Wrong Max Energy Order");
+    }
   }
 }
@@ -80,11 +91,17 @@
 
 G4double G4QDiscProcessMixer::PostStepGetPhysicalInteractionLength(const G4Track& Track,
-			                                                         G4double   PrevStSize,
-			                                                         G4ForceCondition* F)
+                                                                   G4double  PrevStSize,
+                                                                   G4ForceCondition* F)
 {
   G4double kEn=Track.GetDynamicParticle()->GetKineticEnergy(); // Projectile kinetic energy
   G4int maxDP=theDPVector.size();
-  if(maxDP) for(G4int i=0; i<maxDP; ++i) if(kEn < theDPVector[i]->second)
+  if(maxDP) for(G4int i=maxDP-1; i>-1; i--) if(kEn < theDPVector[i]->second)
     return theDPVector[i]->first->PostStepGetPhysicalInteractionLength(Track,PrevStSize,F);
+  return DBL_MAX;
+}
+
+// A fake class for compilation only
+G4double G4QDiscProcessMixer::GetMeanFreePath(const G4Track&, G4double, G4ForceCondition*)
+{
   return DBL_MAX;
 }
@@ -95,5 +112,5 @@
   G4double kEn=Track.GetDynamicParticle()->GetKineticEnergy(); // Projectile kinetic energy
   G4int maxDP=theDPVector.size();
-  if(maxDP) for(G4int i=0; i<maxDP; ++i) if(kEn < theDPVector[i]->second)
+  if(maxDP) for(G4int i=maxDP-1; i>-1; i--) if(kEn < theDPVector[i]->second)
   {
     //EnMomConservation= theDPVector[i]->first->GetEnegryMomentumConservation();
